# Development coordination disorder in children – diagnosis, relationship to brain function

Developmental coordination disorder is one of the specific learning disabilities. It is described as the impaired development of coordination, which cannot be explained by overall intellectual retardation or specific acquired nervous disorder. The project deals with the structure of disorder and examines the possibility of using the method of evoked potentials to investigate it. It turns out that children with lower levels of coordination process evoked potentials in their brains differently than children with normal levels of coordination. Differences are described in the management of physical activities of children, depending on the level of coordination development and their intellect. There are used the test MABC, analysis of evoked potentials and other selected tests related to specific learning and intellect disabilities.

See the [NEUROINFORMATICS reasearch group article](http://neuroinformatics.kiv.zcu.cz/articles/read/coordination-disorder-in-children_2015-01-20) for more informations about this experiment.

> The datasets were converted to the NIX data standard from the original experiment data stored in the [EEGbase portal](http://eegdatabase.kiv.zcu.cz/).